#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void *an_malloc_2D( x_size, y_size, size )
	int x_size, y_size, size ;
{
	int y ;
	char **p, *q ;

	p = (char **)malloc( y_size*sizeof(char *) + x_size*y_size*size ) ;

	if ( p ) {
		q = (char *)p + y_size*sizeof(char *) ;
		for ( y=0; y<y_size; ++y, q+=x_size*size )
			p[y] = q ;
	}

	return p ;
}

void *an_malloc_3D( x_size, y_size, t_size, size )
	int x_size, y_size, t_size, size ;
{
	int x, t, y ;
	char ***p, *q, *r ;

	p = (char ***)malloc(	  t_size*sizeof(char **)
				+ y_size*t_size*sizeof(char *)
				+ x_size*y_size*t_size*size ) ;

	if ( p ) {
		q = (char *)p + t_size*sizeof(char **) ;
		for ( t=0; t<t_size; ++t, q+=y_size*sizeof(char *) ) {
			p[t] = (char **)q ;
			r = (char *)p + t_size*sizeof(char **)
				+ y_size*t_size*sizeof(char *)
				+ x_size*y_size*size*t ;
			for ( y=0; y<y_size; ++y, r+=x_size*size )
				p[t][y] = r ;
		}
	}

	return p ;
}

